import { Node } from "ts-simple-ast";
import * as ts from 'typescript';
import { CodeFixOptions } from 'ts-simple-ast-extra';
import { ToolConfig } from "typescript-plugins-text-based-user-interaction";
import { SignatureAbstractCodeFix } from '../SignatureAbstractCodeFix';
import { TargetInfo } from '../util';
/**
 * # Description
 *
 *  Allows users to change a signature parameter order. see README
 *
 * # TODO
 *  * refactor a implementation method wont change its interface signature - super
 *  * constructors not supported
    * we could give a more intuitive text-based API by letting the user provide the new signature. Then we create a new function with that signature in order to parse it correctly.
    * visual feedback select the arguments after refactor and put the cursor where in the middle
 */
export declare class ReorderParamsCodeFixImpl extends SignatureAbstractCodeFix {
    name: string;
    config: any;
    getTargetInfo(sourceFile: ts.SourceFile, position: number): TargetInfo | undefined;
    printRefactorSuggestionMessage(targetInfo: TargetInfo): string;
    getTextUIToolConfig(): ToolConfig;
    private printReorderExample;
    helpText: string;
    helpComment(): string;
    apply(arg: CodeFixOptions): void;
}
/**
 * For all references that must be refactored calls reorderArgsOrParams.
 *
 * @param targetDeclaration the function-like declaration to reorder its parameters
 * @param reorder [1,0] means switching the positions between first and second params
 */
export declare function reorderParameters(node: Node, reorder: number[], log: (msg: string) => void): void;
