import * as ts from 'typescript';
import { CallExpression, Node, ReferenceFindableNode, SignaturedDeclaration } from "ts-simple-ast";
export interface TargetInfo {
    name: string;
    targetNode: ts.Node;
    parameterCount: number;
    argumentCount: number;
}
export declare function getTargetNode(sourceFile: ts.SourceFile, position: number): ts.Node;
export declare function getTargetInfo(sourceFile: ts.SourceFile, position: number, predicate?: (n: ts.Node) => boolean): TargetInfo | undefined;
/**
 * collect al references of given node and returns those nodes that need to be refactored
 */
export declare function getAllCallsExpressions(targetDeclaration: Node & ReferenceFindableNode, log: (msg: string) => void): ((CallExpression | SignaturedDeclaration) & Node)[];
export declare type SignatureParentType = CallExpression & Node | SignaturedDeclaration & Node;
export declare function applyToSignature(node: Node, fn: (argsOrParams: ReadonlyArray<Node>, parent: SignatureParentType, returnValueOrType: Node) => void, log?: (msg: string) => void): void;
